#include "copyright.h"
/*
 * list all sdgraph devices
 * assume that more() is already initialised
 */
#include "options.h"
#include <stdio.h>
#include <ctype.h>
#include "sm_declare.h"

#define SIZE 130
extern int sm_interrupt;			/* respond to ^C */

int
stg_list()
{
   char ch,
	dev[81],			/* name or alias of device */
   	file[81],
	*graphcap,			/* name of graphcap file */
	line[SIZE+1],			/* line from file */
	outline[SIZE+1];		/* line to print */
   FILE *fil;				/* graphcap file */
   int i,j,k;

   if((graphcap = get_val("graphcap")) == NULL) {
      msg("File graphcap is not defined\n");
      return(0);
   }

   (void)more((char *)NULL);		/* initialise more */

   while(*graphcap != '\0') {
      for(j = 0;j < 80 && *graphcap != '\0' && !isspace(*graphcap);j++) {
	 file[j] = *graphcap++;
      }
      file[j] = '\0';
      while(isspace(*graphcap)) graphcap++;

      if((fil = fopen(file,"r")) == NULL) {
	 msg_1s("Can't open file %s\n",file);
	 return(0);
      }

      while(!sm_interrupt && fgets(line,SIZE,fil) != NULL) {
	 outline[0] = '\0';
	 if((i = strlen(line)) == 0) {		/* blank */
	    continue;
	 } else if(line[0] == '#') {		/* comment */
	    continue;
	 } else if(isspace(line[0])) {		/* continuation */
	    continue;
	 } else {
	    k = 0;
	    for(i = j = 0;(ch = line[i]) != ':';i++) {
	       dev[j++] = ch;
	       if(ch == '|' || ch == '\0') {
		  dev[j-1] = '\0';
		  if(k == 1) {
		     k = 2;
		     (void)strncat(outline,"( ",SIZE);
		  }
		  (void)strncat(outline,dev,SIZE);
		  (void)strncat(outline," ",SIZE);
		  if(k == 0) {
		     k = 1;
		  }
		  j = 0;
		  if(ch == '\0') break;
	       }
	    }
	    dev[j] = '\0';
	    if(k == 2) (void)strncat(outline,") ",SIZE);
	    (void)strncat(outline,": ",SIZE);
	    (void)strncat(outline,dev,SIZE);
	    (void)strncat(outline,"\n",SIZE);
	    if(more(outline) < 0) {
	       (void)fclose(fil);
	       return(-1);
	    }
	 }
      }
      (void)fclose(fil);
   }
   return(0);
}
