#include "copyright.h"
#include <stdio.h>
#include "options.h"
#include "sm.h"
#include "tty.h"
#include "stdgraph.h"
#include "sm_declare.h"
/*
 * stg_reloc -- Output a device move instruction to move to the position (x,y)
 * in SCREEN coordinates.
 *
 * stg_dot  -- draw a single pixel dot at (x,y)
 */
void
stg_reloc(x, y)
int x, y;			/* destination */
{
   if((int)(x*xscreen_to_pix) != g_xc || (int)(y*yscreen_to_pix) != g_yc) {
      ttyputs(g_out,g_tty,g_sg->sg_startmove,1);
      
      g_xc = g_reg[1].i = x*xscreen_to_pix;
      g_yc = g_reg[2].i = y*yscreen_to_pix;
      g_reg[E_IOP].i = 0;
      stg_encode(g_xy,g_mem,g_reg);
      ttwrite(g_out,g_mem,g_reg[E_IOP].i);
      ttyputs(g_out, g_tty, g_sg->sg_endmove, 1);
   }
}

/***************************************************************/
/*
 * Draw a sm_dot. Note that we have just moved to the current sm_location, so if
 * startmark is null we needn't move there again
 */
int
stg_dot(x, y)
int x, y;			/* location */
{
   if(g_sg->sg_startmark[0] == '\0' && g_sg->sg_endmark[0] == '\0') {
      return(-1);
   } else {
      ttyputs(g_out,g_tty,g_sg->sg_startmark,1);
      g_reg[1].i = x*xscreen_to_pix;	/* convert SCREEN to device coords */
      g_reg[2].i = y*yscreen_to_pix;
      g_reg[E_IOP].i = 0;
      stg_encode(g_xy,g_mem,g_reg);
      ttwrite(g_out,g_mem,g_reg[E_IOP].i);
   }

   ttyputs(g_out,g_tty,g_sg->sg_endmark,1);
   return(0);
}
