#error You must edit options.h before SM will compile.
SM will not compile until you have removed these seven lines
By removing them you acknowledge that you have read our
copyright notices, and you confirm that you have a legal
copy of SM. If you are not sure of your status please send
email to either Robert Lupton (rhl@astro.princeton.edu) or
Patricia Monger (monger@mcmaster.ca).
/*
 * This file is used to specify user options for SM.
 * It should be included by all files that are to be linked
 * into SM, including device drivers
 *
 * You may well be able to use the script set_opts in the directory
 * above this file to set your compilation environment automatically,
 * and never edit this file be hand.
 *
 * After editing this file, you may also have to fiddle with the
 * Makefiles (e.g., does your system understand ranlib?)
 *
 * (If you don't know C, stuff like this from slash-star to star-slash
 * is a comment. A line starting in the first column like
#define ABC xyz
 * says to define a symbol ABC to have the value xyz. Inside a comment
 * it doesn't do anything, so to activate a definition move it outside
 * the comment, i.e. swap it with the following star-slash line. Comments
 * don't nest, by the way, so that's why I'm writing star-slash)
 *
 * First which device drivers:
 */

/*
 * BGI graphics on a PC (device bgi)
 * You must have the Borland C-compiler version 3.0 or later to use this driver
#define BGI
 */

/*
 * Imagen Printer - IMPRESS language (device imagen)
#define IMAGEN
 */

/*
 * Microsoft Windows (device msw)
 * You must have the Borland C-compiler version 3.0 or later to use this driver
#define MSWINDOWS
 */

/*
 * Silicon Graphics GL driver (device sgi)
 * You should add $(SGILIB) to $(LDFLAGS) in src/Makefile
#define SGI
 */

/*
 * SunView driver (device sunview)
 * You should add $(SUNVLIB) to $(LDFLAGS) in src/Makefile
#define SUN_VIEW
 */

/*
 * sunwindowsdriver (device sunwindows)
 * This is obselete -- use sunview instead
 * You should add $(SUNLIB) to $(LDFLAGS) in src/Makefile
#define SUNWINDOWS
 */

/*
 * X-windows V10 driver (device xwindows)
 * If you are using X11 DON'T define this!
 * You should add $(XLIB) to $(LDFLAGS) in src/Makefile
#define XWINDOWS
 */

/*
 * X-windows V11 driver (device x11)
 * You should add $(XLIB11) to $(LDFLAGS) in src/Makefile
#define X11
 */

/*
 * If you want to use backing store even when SM doesn't think that
 * you need to, define this symbol. This is typically used if you
 * have an application that calls SM libraries and also does a lot
 * of calculations, and wants the graphics to remain updated.
#define FORCE_BACKING_STORE
 */

/*
 * Driver for a Unix PC (a 3b1)
#define UNIXPC
 */

/* 
 * Driver for VAX workstations using UIS calls
#define VAXUIS 
 */

/*
 * Choose your favourite random number generator here.
 * RAND() returns a number in [0,MAX_RAND], SRAND() is used to reset
 * the random number generator.
 *
 * If you don't set MAX_RAND we try to set a suitable value at the
 * end of this file.
 */
#define RAND rand
#define SET_RAND srand


/*
 * You may well not have to edit this file further; what we believe to
 * be correct settings for
 *	alliant hp rs6000 sgi sun vms
 * are set automatically.
 */

/*
 * Now choose your operating system: choose no more than one of the following:
 */
/*
 * If you are running on a machine running System V Unix, define this
#define SYS_V
 */
/*
 * If you are running VMS define this (it's probably done automatically)
#define VMS
 */
#if defined(vms)
#  define VMS
#endif
/*
 * If you're running this on an IBM PC,
 * __MSDOS__ and maybe __BORLANDC__ will be defined (and used)
 */

/*
 * Set some options to do with compiling SM:
 */
/*
 * If your compiler doesn't support alloca() define this:
 * (SYS V, VMS, and RISC/6000 compilers don't, but we deal with that for you)
#define NO_ALLOCA
 */

/*
 * If your compiler doesn't support ftruncate() define this:
 * (SYS V and VMS compiler don't, but we deal with that for you)
#define NO_FTRUNCATE
 */

/*
 * If your compiler doesn't support memcpy() define this:
#define NO_MEMCPY
 */

/*
 * If your compiler doesn't support system() define this:
 * (VMS doesn't, but we deal with that for you)
#define NO_SYSTEM
 */

/*
 * If your compiler doesn't support select() define this:
 * (VMS doesn't, but we deal with that for you)
#define NO_SELECT
 */

/*
 * If you have the readdir() system call define this; should be OK
 * for most BSD unix systems but not VMS or System V (we deal with VMS
 * and SysV for you)
 *
 * SM will compile without this, but APROPOS won't be able to search
 * help files
 */
#if !defined(VMS) && !defined(SYS_V)
#  define HAVE_READDIR
#endif

/*
 * The old option RENAME has been removed. As of version 2.3.0, all
 * user callable SM functions begin sm_ (e.g. sm_line).
 */

/*
 * Set the debug level for compiling. Most users should not define this,
 * as it can slow things down. On the other hand, if you are debugging
 * you might try setting it. For example, on a sun DEBUG==2 checks the
 * heap on each transaction
#define DEBUG 2
 */

/*
 * Did an exclamation mark (!) introduce a comment in Mongo macros?
 * (used by READ OLD)
#define EXCLAMATION_IS_COMMENT 1
 */

/*
 * This is the log_10 of the largest floating point number that you
 * can handle (or at least, it is no larger than that). It's used to
 * prevent certain overflows.
 *			 (MUST BE DEFINED)
 */
#define MAX_POW 37

/*
 * If FITS files must have their byte order swapped, define this
 * (e.g. on a vax, but we do it for you)
#define NEED_SWAP
 */

/*
 * Now for Posix compliance. Posix is an ANSI standard for a unix-like
 * O/S and compilers that think that they are supporting it sometimes
 * argue with SM. If this is a problem define this symbol. We do it
 * for you for IBM RISC/6000 machines.
#define _POSIX_SOURCE 1
 */

/*
 * The following options are to do with ANSI compilance. If you have a
 * fully ANSI C compiler, you can skip the rest of the file (as we'll
 * set the correct values if __STDC__ is defined as 1). If you don't have
 * an ANSI compiler, you may need to change some of the values following
 * the "#else" line.  At the moment the only vms compiler that thinks it is
 * ANSI compliant, namely gcc, isn't, so we are punting for the nonce
 */
#if defined(__BORLANDC__) || (__STDC__ == 1 && !(defined(__GNUC__) && defined(VMS))) /* Hurrah! ANSI */
#  define ANSI_CPP			/* preprocessor is ANSI */
#  if !defined(__GNUC__)
#     define ANSI_INCLUDE		/* has the ANSI include files */
#  endif
#  define ANSI_PROTO			/* supports prototypes */
#  define STDARG			/* supports STDARG */
#  define Const const
#  define Signed signed
#  define Void void			/* understands (void *) */
#  define Volatile volatile
/*
 * Many implementations of sscanf don't work with read-only strings,
 * and ANSI compilers are free to put string constants into read-only
 * memory. For ANSI compliant compilers we have provided a function
 * str_scanf that does. If you want to use the system sscanf anyway,
 * define str_scanf to be sscanf (this is done automatically for
 * non-ANSI compilers)
#  define str_scanf sscanf
 */
#else					/* Not ANSI */
#define str_scanf sscanf
/*
 * If your compiler doesn't support memcpy() define this:
 * (The VMS compiler does)
#define NO_MEMCPY
 */

/*
 * If you have an ANSI compiler, it'll want to use ## to concatenate
 * preprocessor tokens. If it does, define this: (must do this for VMS gcc)
#define ANSI_CPP
 */

/*
 * If your compiler has ANSI-compliant system headers you can define this,
 * it'll stop SM from trying to define thigs like strlen() itself
#define ANSI_INCLUDE
 */

/*
 * If your compiler supports function prototypes you can define this.
 * It won't make any difference to running SM whatever you do,
 * but it matters to the authors.
#define ANSI_PROTO
 */

/*
 * If your linker can't find the function strchr(), define this:
 * (not needed for VMS or Unix System V). Similarily for strrchr()
#define strchr index
#define strrchr rindex
 */

/*
 * Some compilers break with functions returning (void *). We get around this
 * by defining a type Void. It's safe to define this to be char, but
 * it'd be better to use void
 *			 (MUST BE DEFINED)
 */
#define Void char

/*
 * If your compiler knows the keywords "const", "signed", or "volatile",
 * define the Capitalised form here as the all-lowercase equivalent.
 * This probably doesn't matter much -- but they must be defined.
#define Const const
#define Signed signed
#define Volatile volatile
 */
#define Const
#define Signed
#define Volatile

#endif					/* __STDC__ */

/******************************************************************/
/*
 * Now deal with those operating system decisions: Users should not
 * have to edit this section
 */
/*
 * The values to return to the operating system. For all Unix systems
 * you want 0 and 1 respectively; VMS wants them reversed
 */
#define EXIT_OK 0
#define EXIT_BAD 1

#if defined(alliant)
#  undef HAVE_READDIR
#  undef MAX_POW
#  define MAX_POW 308
#endif

#if defined(__BORLANDC__)
#  define NO_FTRUNCATE
#endif
#if !defined(STANDALONE)		/* not something like makeyyl */
#   if defined(BGI) && !(!defined(_Windows) && defined(__BORLANDC__))
      #error You have specified the BGI driver, but are not using \
  the borland compiler, or you are using windows
#   endif
#   if defined(MSWINDOWS) && !(defined(_Windows) && defined(__BORLANDC__))
      #error You have specified the MS-Windows driver, but are not using \
  the borland compiler with windows
#   endif
#endif

#if defined(hp)
#  define SYS_V
#endif

#if defined(rs6000)
#  if !defined(unix)
#     define unix
#  endif
#  define NO_ALLOCA
#  define _POSIX_SOURCE 1
#endif

#if defined(sgi)
#  if !defined(unix)
#     define unix
#  endif
#  define ANSI_INCLUDE
#  define SYS_V
#  define STDARG
#  undef Const
#  undef Signed
#  undef Volatile
#  define Const const
#  define Signed signed
#  define Volatile volatile
#endif

#if defined(sun)
#  if !defined(unix)
#     define unix
#  endif
#     define SUN_BROKEN_DEFNS		/* this is terrible! It's due to the
					   Sun OS 4.1.1 headers being broken;
					   they conflict with ... prototypes */
#  if defined(solaris)
#     define ANSI_CPP
#     define ANSI_INCLUDE
#     define _POSIX_SOURCE 1
#     define SYS_V
#     undef Const
#     undef Signed
#     undef Volatile
#     define Const const
#     define Signed signed
#     define Volatile volatile
#     undef SUN_BROKEN_HEADERS		/* hurrah! */
#  endif
#  if (defined(__STDC__) && __STDC__ == 0) /* probably acc */
#     define ANSI_CPP
#     define ANSI_INCLUDE
#     define NO_ALLOCA
#     undef Const
#     undef Signed
#     undef Volatile
#     define Const const
#     define Signed signed
#     define Volatile volatile
#  endif
#endif

#if defined(SYS_V)
#  if !defined(__GNUC__)
#     define NO_ALLOCA
#  endif
#  define NO_FTRUNCATE
#endif

#if defined(VMS) 
#  define ANSI_INCLUDE
#  undef EXIT_OK
#  undef EXIT_BAD
#  define EXIT_OK 1
#  define EXIT_BAD 0
#  define NO_ALLOCA
#  define NO_FTRUNCATE
#  define NO_SELECT
#  define NO_SYSTEM
#  define pow vms_pow			/* theirs is/was broken */
#endif

#if defined(_POSIX_SOURCE)
#  define HAVE_READDIR
#endif

#ifdef vax
#define NEED_SWAP
#endif
/*
 * Implement ANSI_CPP
 */
#if defined(ANSI_CPP)
#  define _CONCATENATE(P,F) P ## F
#  define CONCATENATE(P,F) _CONCATENATE(P,F)
#else
#  define CONCATENATE(P,F) P/**/F
#endif
/*
 * Finish with random numbers, now we know if we are POSIX or not
 */
#if !defined(MAX_RAND)
#  if defined(_POSIX_SOURCE)
#     define MAX_RAND RAND_MAX
#  else
#     define MAX_RAND (((unsigned)1<<(8*sizeof(int) - 1)) - 1)
#  endif
#endif
/*
 * Include file book-keeping:
 */
#if !defined(INC_OPTIONS_H)
#  define INC_OPTIONS_H
#endif
