#include "copyright.h"
#define INC_YACCUN_H
/*
 * these are the typedefs for the yacc union 
 */
#define CHARMAX 80			/* maximum size of word */

typedef struct {			/* a pair of floats + 1 */
   float a,b,
   	 med;
} PAIR;

typedef struct {
   char *start,				/* start of string */
        *end;				/* end of string (just before '\0') */
} STR;

typedef struct {
   int nitem,				/* number of items on list */
       nmax;				/* max number with space allocated */
   char **i_list,			/* array of pointers to items */
	*i_space;			/* storage for items */
} TOK_LIST;

union yystype {				/* union for yacc variable stack */
   char charval[CHARMAX];
   float floatval;
   int intval;
   PAIR pairval;
   STR strval;
   TOK_LIST *t_list;
   VECTOR vector;
};
#define YYSTYPE union yystype
